C  CDRN5  SOLUTE SINKS AT DRAINS  
C     ******************************************************************
C
      SUBROUTINE CDRN5FM(NDRAIN,MXDRN,
     *                   DRAI,IBOUND,NCOL,NROW,NLAY,
     *  SNKFLO,
     *  NSCOL,NSROW,NSLAY,IOUTS,NDRNVL,IDRNAL,ICONLY,KSTP)
C
C     ******************************************************************
C
      DIMENSION DRAI(NDRNVL,MXDRN)
      DIMENSION IBOUND(NCOL,NROW,NLAY),
     1  SNKFLO(NSCOL,NSROW,NSLAY)
C
      COMMON /SUBGRD/
     *  ISCOL1,ISCOL2,ISROW1,ISROW2,ISLAY1,ISLAY2,ISUBGD
C
C     ******************************************************************
C
C  RETURN IF NO ACTIVE DRAINS THIS PERIOD
      IF(NDRAIN.LE.0) RETURN
C
C  ADD DRAINS (SINKS ONLY)
      IDRNSG=0
      ITHKSG=0
      IPRNT=0
C  CHECK EXISTENCE OF CBCALLOCATE OPTION
      IF (IDRNAL.NE.1) THEN
         WRITE(IOUTS,*) ' ERROR, CBCALLOCATE OPTION MUST BE ',
     *        'SPECIFIED IN DRAIN INPUT DATA'
         STOP
      ENDIF
C
      DO 10 ID=1,NDRAIN
         K=DRAI(1,ID)
         KS=K-ISLAY1+1
         IF(KS.LT.1.OR.KS.GT.NSLAY) GO TO 10
         I=DRAI(2,ID)
         IS=I-ISROW1+1
         IF(IS.LT.1.OR.IS.GT.NSROW) GO TO 10
         J=DRAI(3,ID)
C  SKIP DRAINS IN FIXED HEAD CELLS
         IF(IBOUND(J,I,K).LE.0) THEN
           ITHKSG=ITHKSG+1
           GO TO 10
         ENDIF
         JS=J-ISCOL1+1
         IF(JS.LT.1.OR.JS.GT.NSCOL) GO TO 10
         IF(KSTP.EQ.1) THEN
            IF(IPRNT.EQ.0) WRITE(IOUTS,1000)
 1000       FORMAT(//' DRAINS WITHIN SUBGRID THIS STRESS PERIOD'//
     1      '  DRAIN NO.   LAYER      ROW     COLUMN'/
     2      1X,40('-'))
            IPRNT=1
            WRITE(IOUTS,'(1X,I6,3I10)') ID,K,I,J
         END IF
         IF(ICONLY.EQ.1) THEN
            IDRNSG=IDRNSG+1
         ELSE
            SNKFLO(JS,IS,KS)=SNKFLO(JS,IS,KS)+DRAI(NDRNVL,ID)
         ENDIF
   10 CONTINUE
C
      IF(IDRNSG.GT.0) THEN
         WRITE(IOUTS,*) ' ERROR,',IDRNSG,' DRAINS WITHIN SUBGRID, ',
     *        'BUT ICONLY=1, STOPPING'
         STOP
      END IF
C  WARN IF WELL NODE WITHIN SUBGRID, BUT NO FLOW ASSOC WITH IT
      IF(ITHKSG.GT.0) THEN
         WRITE(IOUTS,*) ' WARNING:',ITHKSG,' DRAIN NODES',
     *     ' SKIPPED WITHIN SUBGRID (IBOUND <= 0)'
      ENDIF
C
      RETURN
      END
