      SUBROUTINE INIT(IBOUND,CI,CIN,CIR,CIRH,CIRL,IND,MRNO,MRNO0,
     X     EPSSLV,MAXIT,IDIREC,
     X     NCOL,NROW,NLAY,NSCOL,NSROW,NSLAY,NBN,NRN)
C.....Static initialization for solver
      INTEGER CIN,IBOUND
      DIMENSION CIN(6,*),IBOUND(NCOL,NROW,NLAY)
      INTEGER CI,CIR,CIRH,CIRL,MRNO,MRNO0,IND
c      DOUBLE PRECISION RS,VA,VAD,RHS,AP,PP,RA,RR,SS,XX,WW,WORK
      DIMENSION CI(6,*),CIR(19,*),CIRH(10,*),CIRL(10,*),
     X     MRNO(*),MRNO0(*),IND(*)
      COMMON/CAIS/MAR(6,6),MAR1(19,19)
      COMMON /SUBGRD/
     *  ISCOL1,ISCOL2,ISROW1,ISROW2,ISLAY1,ISLAY2,ISUBGD
C...
C.....Create cell connection list
               NX=NSCOL
               NY=NSROW
               NZ=NSLAY
               NXY=NX*NY
               NXYZ=NSCOL*NSROW*NSLAY
      DO 70 M=1,NXYZ
               DO 63 IC=1,6
   63             CIN(IC,M)=0
C.....Skip excluded cells
               CALL MTOIJK(M,IS,JS,KS,NSCOL,NSROW)
               K=KS+ISLAY1-1
               I=JS+ISROW1-1
               J=IS+ISCOL1-1
               IF(IBOUND(J,I,K).EQ.0) GO TO 70
C.....Left
               IF(IS.GT.1.AND.IBOUND(J-1,I,K).NE.0) CIN(3,M)=M-1
C.....Right
               IF(IS.LT.NX.AND.IBOUND(J+1,I,K).NE.0) CIN(4,M)=M+1
C.....Front
               IF(JS.GT.1.AND.IBOUND(J,I-1,K).NE.0) CIN(2,M)=M-NX
C.....Back
               IF(JS.LT.NY.AND.IBOUND(J,I+1,K).NE.0) CIN(5,M)=M+NX
C.....Below
               IF(KS.GT.1.AND.IBOUND(J,I,K-1).NE.0) CIN(1,M)=M-NXY
C.....Above
               IF(KS.LT.NZ.AND.IBOUND(J,I,K+1).NE.0) CIN(6,M)=M+NXY
   70          CONTINUE
C.....Establish red-black ordering
        CALL REORDR(IDIREC,CI,CIR,CIRH,CIRL,IND,MRNO,MRNO0,
     X     NBN,NRN,NX,NY,NZ,NXYZ)
         RETURN
         END
      SUBROUTINE LDCI(CI,MRNO,NX,NY,NZ)
C.....Loads the CI array for connected nodes based on the renumbered
C.....     mesh
      INTEGER CI,I,MRNO,NX,NY,NZ,NXY,NXYZ,KX,KY,KZ,M
      DIMENSION CI(6,*),I(6),MRNO(*)
C...
      NXY = NX*NY
      NXYZ = NXY*NZ
      DO 1000 M=1,NXYZ
         CALL MTOIJK(M,KX,KY,KZ,NX,NY)
         MA = MRNO(M)
C.....MA is 0 for excluded cells
         IF(MA.GT.0) THEN
            I(1) = M-NXY
            I(2) = M-NX
            I(3) = M-1
            I(4) = M+1
            I(5) = M+NX
            I(6) = M+NXY
C.....I is natural node number
            DO 10 J=1,6
               IF ( (I(J) .GE. 1) .AND. (I(J) .LE. NXYZ)) 
     X              CI(J,MA) = MRNO(I(J))
   10       CONTINUE
C.....Modify for ends of node rows
            IF (KZ .EQ. 1) CI(1,MA) = 0
            IF (KY .EQ. 1) CI(2,MA) = 0
            IF (KX .EQ. 1) CI(3,MA) = 0
            IF (KX .EQ. NX) CI(4,MA) = 0
            IF (KY .EQ. NY) CI(5,MA) = 0
            IF (KZ .EQ. NZ) CI(6,MA) = 0
         ENDIF
 1000 CONTINUE
      RETURN
      END
      SUBROUTINE LDCIR(CIR,CIRL,CIRH,CI,NBN,NRN)
C.....Loads the CIR, CIRL, CIRH index arrays for the 
C.....     conjugate gradient solver
      INTEGER CI,CIR,CIRL,CIRH,NBN,NRN
      DIMENSION CIR(19,*),CI(6,*),CIRL(10,*),CIRH(10,*)
c...not sure if this loop 99 is needed
      DO 99 K=1,NBN
         CIRL(1,K)=0
         CIRH(1,K)=0
   99 CONTINUE
      DO 100 K=1,NBN
         KK = NRN+K
C.....Lower level
         IX = CI(1,KK)
         IF (IX .EQ. 0) THEN
            DO 5 J=1,5
               CIR(J,K) = 0
    5       CONTINUE
         ELSE
            DO 10 J=1,5
               IY = CI(J,IX)
               IF (IY .EQ. 0) THEN
                  CIR(J,K) = 0
               ELSE
                  IND = IY-NRN
                  CIR(J,K) = IND
                  IF (IND .LT. K) THEN
                     CIRL(1,K) = CIRL(1,K)+1
                     CIRL(CIRL(1,K)+1,K) = J
                  ENDIF
                  IF (IND .GT. K) THEN
                     CIRH(1,K) = CIRH(1,K)+1
                     CIRH(CIRH(1,K)+1,K) = J
                  ENDIF
               ENDIF
   10       CONTINUE
         ENDIF
C.....Same level
         IX = CI(2,KK)
         IF (IX .EQ. 0) THEN
            DO 15 J=6,8
               CIR(J,K) = 0
   15       CONTINUE
         ELSE
            DO 20 J=2,4
               IY = CI(J,IX)
               IF (IY .EQ. 0) THEN
                  CIR(J+4,K) = 0
               ELSE
                  IND = IY-NRN
                  CIR(J+4,K) = IND
                  IF (IND .LT. K) THEN
                     CIRL(1,K) = CIRL(1,K)+1
                     CIRL(CIRL(1,K)+1,K) = J+4
                  ENDIF
                  IF (IND .GT. K) THEN
                     CIRH(1,K) = CIRH(1,K)+1
                     CIRH(CIRH(1,K)+1,K) = J+4
                  ENDIF
               ENDIF
   20       CONTINUE
         ENDIF
         IX = CI(3,KK)
         IF (IX .EQ. 0) THEN
            CIR(9,K) = 0
         ELSE
            IY = CI(3,IX)
            IF (IY .EQ. 0) THEN
               CIR(9,K) = 0
            ELSE
               IND = IY-NRN
               CIR(9,K) = IND
               IF (IND .LT. K) THEN
                  CIRL(1,K) = CIRL(1,K)+1
                  CIRL(CIRL(1,K)+1,K) = 9
               ENDIF
               IF (IND .GT. K) THEN
                  CIRH(1,K) = CIRH(1,K)+1
                  CIRH(CIRH(1,K)+1,K) = 9
               ENDIF
            ENDIF
         ENDIF
C...
         CIR(10,K) = K
C...
         IX = CI(4,KK)
         IF (IX .EQ. 0) THEN
            CIR(11,K) = 0
         ELSE
            IY = CI(4,IX)
            IF (IY .EQ. 0) THEN
               CIR(11,K) = 0
            ELSE
               IND = IY-NRN
               CIR(11,K) = IND
               IF (IND .LT. K) THEN
                  CIRL(1,K) = CIRL(1,K)+1
                  CIRL(CIRL(1,K)+1,K) = 11
               ENDIF
               IF (IND .GT. K) THEN
                  CIRH(1,K) = CIRH(1,K)+1
                  CIRH(CIRH(1,K)+1,K) = 11
               ENDIF
            ENDIF
         ENDIF
         IX = CI(5,KK)
         IF (IX .EQ. 0) THEN
            DO 25 J=12,14
               CIR(J,K) = 0
   25       CONTINUE
         ELSE
            DO 30 J=3,5
               IY = CI(J,IX)
               IF (IY .EQ. 0) THEN
                  CIR(J+9,K) = 0
               ELSE
                  IND = IY-NRN
                  CIR(J+9,K) = IND
                  IF (IND .LT. K) THEN
                     CIRL(1,K) = CIRL(1,K)+1
                     CIRL(CIRL(1,K)+1,K) = J+9
                  ENDIF
                  IF (IND .GT. K) THEN
                     CIRH(1,K) = CIRH(1,K)+1
                     CIRH(CIRH(1,K)+1,K) = J+9
                  ENDIF
               ENDIF
   30       CONTINUE
         ENDIF
C.....Upper level
         IX = CI(6,KK)
         IF (IX .EQ. 0) THEN
            DO 35 J=15,19
               CIR(J,K) = 0
   35       CONTINUE
         ELSE
            DO 40 J=2,6
               IY = CI(J,IX)
               IF (IY .EQ. 0) THEN
                  CIR(J+13,K) = 0
               ELSE
                  IND = IY-NRN
                  CIR(J+13,K) = IND
                  IF (IND .LT. K) THEN
                     CIRL(1,K) = CIRL(1,K)+1
                     CIRL(CIRL(1,K)+1,K) = J+13
                  ENDIF
                  IF (IND .GT. K) THEN
                     CIRH(1,K) = CIRH(1,K)+1
                     CIRH(CIRH(1,K)+1,K) = J+13
                  ENDIF
               ENDIF
   40       CONTINUE
         ENDIF
  100 CONTINUE
      RETURN
      END
      SUBROUTINE LDIND(IDIREC,IND,NX,NY,NZ)
C.....Loads the IND array with a natural numbering in the permutation
C.....     of x, y, and z specified by IDIREC
      INTEGER IND,IDIREC,NX,NY,NZ
      DIMENSION IND(*)
C...
      IF (IDIREC.EQ.1) THEN
         IX = 1
         IY = NX
         IZ = NX*NY
      ELSEIF (IDIREC.EQ.2) THEN
         IX = 1
         IY = NX*NZ
         IZ = NX
      ELSEIF (IDIREC.EQ.3) THEN
         IX = NY
         IY = 1
         IZ = NX*NY
      ELSEIF (IDIREC.EQ.4) THEN
         IX = NZ*NY
         IY = 1
         IZ = NY
      ELSEIF (IDIREC.EQ.5) THEN
         IX = NZ
         IY = NX*NZ
         IZ = 1
      ELSEIF (IDIREC.EQ.6) THEN
         IX = NY*NZ
         IY = NZ
         IZ = 1
      ENDIF
      L = 0
      LK = 1
      DO 30 K=1,NZ
         LJ = LK
         DO 20 J=1,NY
            LI = LJ
            DO 10 I=1,NX
               L = L+1
               IND(LI) = L
               LI = LI+IX
   10       CONTINUE
            LJ = LJ+IY
   20    CONTINUE
         LK = LK+IZ
   30 CONTINUE
      RETURN
      END
C **********************************************************************  B  20
C                                                                         B  30
      BLOCK DATA                                                          B  40
      COMMON /CAIS/ MAR(6,6),MAR1(19,19)                                  B 130
      DATA MAR /10,05,04,03,02,01, 15,10,08,07,06,02, 16,12,10,09,07,03,  B 210
     1          17,13,11,10,08,04, 18,14,13,12,10,05, 19,18,17,16,15,10/  B 220
      DATA MAR1/10, 5, 4, 3, 2, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0,0   B 230
     1         ,15,10, 8, 7, 6, 5, 4, 3, 0, 2, 0, 0, 0, 0, 1, 0, 0, 0,0   B 240
     1         ,16,12,10, 9, 7, 0, 5, 0, 4, 3, 0, 2, 0, 0, 0, 1, 0, 0,0   B 250
     1         ,17,13,11,10, 8, 0, 0, 5, 0, 4, 3, 0, 2, 0, 0, 0, 1, 0,0   B 260
     1         ,18,14,13,12,10, 0, 0, 0, 0, 5, 0, 4, 3, 2, 0, 0, 0, 1,0   B 270
     1         , 0,15, 0, 0, 0,10, 8, 7, 0, 6, 0, 0, 0, 0, 2, 0, 0, 0,0   B 280
     1         , 0,16,15, 0, 0,12,10, 9, 8, 7, 0, 6, 0, 0, 3, 2, 0, 0,0   B 290
     1         , 0,17, 0,15, 0,13,11,10, 0, 8, 7, 0, 6, 0, 4, 0, 2, 0,0   B 300
     1         , 0, 0,16, 0, 0, 0,12, 0,10, 9, 0, 7, 0, 0, 0, 3, 0, 0,0   B 310
     1         ,19,18,17,16,15,14,13,12,11,10, 9, 8, 7, 6, 5, 4, 3, 2,1   B 320
     1         , 0, 0, 0,17, 0, 0, 0,13, 0,11,10, 0, 8, 0, 0, 0, 4, 0,0   B 330
     1         , 0, 0,18, 0,16, 0,14, 0,13,12, 0,10, 9, 7, 0, 5, 0, 3,0   B 340
     1         , 0, 0, 0,18,17, 0, 0,14, 0,13,12,11,10, 8, 0, 0, 5, 4,0   B 350
     1         , 0, 0, 0, 0,18, 0, 0, 0, 0,14, 0,13,12,10, 0, 0, 0, 5,0   B 360
     1         , 0,19, 0, 0, 0,18,17,16, 0,15, 0, 0, 0, 0,10, 8, 7, 6,2   B 370
     1         , 0, 0,19, 0, 0, 0,18, 0,17,16, 0,15, 0, 0,12,10, 9, 7,3   B 380
     1         , 0, 0, 0,19, 0, 0, 0,18, 0,17,16, 0,15, 0,13,11,10, 8,4   B 390
     1         , 0, 0, 0, 0,19, 0, 0, 0, 0,18, 0,17,16,15,14,13,12,10,5   B 400
     1        , 0, 0, 0, 0, 0, 0, 0, 0, 0,19, 0, 0, 0, 0,18,17,16,15,10/  B 410
      END                                                                 B 420
C
      SUBROUTINE RBORD(MRNO0,NX,NY,NZ)
C.....Maps the natural node number, M, into the red-black node
C.....     number, MRNO0, based on renumbering sweeps in the x, then y,
C.....     then z-directions.
      INTEGER MRNO0,NXYZ,NX,NY,NZ
      DIMENSION MRNO0(*)
C...
      NXY = NX*NY
      NXYZ = NXY*NZ
      NRN = (NXYZ+MOD(NXYZ,2))/2
      DO 10 M=1,NXYZ
C.....Calculate the red-black number for a given natural
C.....     node number,M
      MMOD = MOD(M,2)
      M1 = (M+MMOD)/2
      CALL MTOIJK(M,IX,IY,IZ,NX,NY)
C.....Is sum of indices even or odd?
      IF (MOD(IX+IY+IZ,2) .EQ. 1) THEN
C.....It's a red node
        MRNO0(M) = M1 
      ELSE
C.....It's a black node
        MRNO0(M) = NRN+M1
      ENDIF
   10 CONTINUE 
      RETURN
      END
      SUBROUTINE REORDR(IDIREC,CI,CIR,CIRH,CIRL,IND,MRNO,MRNO0,
     X     NBN,NRN,NX,NY,NZ,NXYZ)
C.....Performs the red-black reordering of the nodes based on the
C.....     selected permutation of the coordinate directions
      INTEGER NX,NY,NZ,NXYZ,IDIREC,IND,NBN,NRN,MRNO
      INTEGER CI,CIR,CIRL,CIRH
      DIMENSION CIR(19,*),CI(6,*),CIRL(10,*),CIRH(10,*)
      DIMENSION MRNO(*),MRNO0(*),IND(*)
C.....Poninters for RCG solver
      COMMON/CAIS/MAR(6,6),MAR1(19,19)
C...
      IF(IDIREC.EQ.1) THEN
         N1 = NX
         N2 = NY
         N3 = NZ
      ELSEIF(IDIREC.EQ.2) THEN
         N1 = NX
         N2 = NZ
         N3 = NY
      ELSEIF(IDIREC.EQ.3) THEN
         N1 = NY
         N2 = NX
         N3 = NZ
      ELSEIF(IDIREC.EQ.4) THEN
         N1 = NY
         N2 = NZ
         N3 = NX
      ELSEIF(IDIREC.EQ.5) THEN
         N1 = NZ
         N2 = NX
         N3 = NY
      ELSEIF(IDIREC.EQ.6) THEN
         N1 = NZ
         N2 = NY
         N3 = NX
      ENDIF
C.....Load MRNO0 using RBORD and N1,N2,N3     
      CALL RBORD(MRNO0,N1,N2,N3)
C.....Now swap indices from MRNO0 to MRNO
      CALL LDIND(IDIREC,IND,NX,NY,NZ)
      DO 50 I=1,NXYZ
         MRNO(IND(I)) = MRNO0(I)
   50 CONTINUE
C.....Load indexing arrays used by the solver, CGRIES 
      NMOD = MOD(NXYZ,2)
      NRN = (NXYZ+NMOD)/2
      NBN = NXYZ-NRN
      CALL LDCI(CI,MRNO,NX,NY,NZ)
      CALL LDCIR(CIR,CIRL,CIRH,CI,NBN,NRN)
      RETURN
      END
