C  SOLUTE SINK/SOURCES AT WELLS 
C  
C     ***************************************************************
C
      SUBROUTINE CWEL5FM(NWELLS,MXWELL,
     *  WELL,IBOUND,NCOL,NROW,NLAY,KSTP,KPER,
     *  SRCFLO,SRCSOL,SNKFLO,
     *  NSCOL,NSROW,NSLAY,IOUTS,NWELVL,IWELAL,IWELLC,ICONLY)
C
C     ***************************************************************
C
C  CWEL5FM  FIND OUT WHICH OF THE WELL AUXILIARY PARAMETERS IS CONC
C  IF NOT FOUND, AND WELLS ARE WITHIN SUBGRID, THEN STOP  
C
      DIMENSION WELL(NWELVL,MXWELL)
      DIMENSION IBOUND(NCOL,NROW,NLAY),
     *  SRCFLO(NSCOL,NSROW,NSLAY),SRCSOL(NSCOL,NSROW,NSLAY),
     *  SNKFLO(NSCOL,NSROW,NSLAY)
      COMMON /WELCOM/WELAUX(5)
      CHARACTER*16 WELAUX
C
      COMMON /MOC3D/ CDEL,RDEL,CNOFLO,CELDIS,FZERO,NZCRIT
      COMMON /SUBGRD/
     *  ISCOL1,ISCOL2,ISROW1,ISROW2,ISLAY1,ISLAY2,ISUBGD
C
C     ***************************************************************
C  CHECK EXISTENCE OF CBCALLOCATE OPTION
      IF (IWELAL.NE.1) THEN
         WRITE(IOUTS,*) ' ERROR, CBCALLOCATE OPTION MUST BE ',
     *        'SPECIFIED IN WELL INPUT DATA'
         STOP
      ENDIF
C
C  SET POINTER TO CONCENTRATION DATA FOR WELLS
      IF(KPER.EQ.1.AND.KSTP.EQ.1) THEN
C COUNT FROM THE TOTAL NUMBER OF STANDARD DATA INPUTS (4)
         NAUX=NWELVL-4-IWELAL
         IWELLC=0
         IF(NAUX.GT.0) THEN
            DO 8 IAUX=1,NAUX
               IF(WELAUX(IAUX).EQ.'CONCENTRATION'.OR.
     *            WELAUX(IAUX).EQ.'CONC') THEN
                  IWELLC=IAUX+4
                  GOTO 9
               END IF
 8          CONTINUE
            WRITE(IOUTS,*) ' WARNING, NO CONCENTRATION DATA READ',
     *         ' FOR WELL NODES'
 9          CONTINUE
         END IF
      END IF
C
C  RETURN IF NO ACTIVE WELL NODES THIS PERIOD
      IF(NWELLS.LE.0) RETURN
C
C5------PRINT WELL CONCENTRATIONS AND FORMULATE
C        SINK AND SOURCE TERMS FOR TRANSPORT
      IWELSG=0
      IERSRC=0
      ITHKSG=0
      IPRNT=0
      DO 10 IW=1,NWELLS
         K=WELL(1,IW)
         KS=K-ISLAY1+1
         IF(KS.LT.1.OR.KS.GT.NSLAY) GO TO 10
         I=WELL(2,IW)
         IS=I-ISROW1+1
         IF(IS.LT.1.OR.IS.GT.NSROW) GO TO 10
         J=WELL(3,IW)
C  SKIP WELLS IN FIXED HEAD CELLS
         IF(IBOUND(J,I,K).LE.0) THEN
           ITHKSG=ITHKSG+1
           GO TO 10
         ENDIF
         JS=J-ISCOL1+1
         IF(JS.LT.1.OR.JS.GT.NSCOL) GO TO 10
         IF(KSTP.EQ.1) THEN
            IF(IPRNT.EQ.0) WRITE(IOUTS,29)
   29       FORMAT(/1H ,' WELL CONCENTRATIONS FOR THIS STRESS PERIOD'
     1      /'  (ONLY FOR WELL NODES WITHIN TRANSPORT SUBGRID)'//
     2      1H ,1X,'WELL NO.  LAYER    ROW   COLUMN    VOL/T   ',
     3      ' SOURCE CONC    MASS/T'/1X,68('-'))
            IPRNT=1
            IF(IWELLC.LE.0) THEN
              WRITE(IOUTS,'(1X,I6,3I8,2X,1PE12.4)') IW,K,I,J,WELL(4,IW)
            ELSE
              RATEC=WELL(4,IW)*WELL(IWELLC,IW)
              WRITE(IOUTS,'(1X,I6,3I8,2X,1P3E12.4)') IW,K,I,J,
     1            WELL(4,IW),WELL(IWELLC,IW),RATEC
            END IF
         END IF
         IF(ICONLY.EQ.1) THEN
            IWELSG=IWELSG+1
         ELSE
            RATE=WELL(NWELVL,IW)
            IF(RATE.LT.0.0) THEN
               SNKFLO(JS,IS,KS)=SNKFLO(JS,IS,KS)+RATE
            ELSE IF(RATE.GT.0.0) THEN
               IF(IWELLC.LE.0) THEN
                 IERSRC=IERSRC+1
               ELSE
                 SRCFLO(JS,IS,KS)=SRCFLO(JS,IS,KS)+RATE
                 RATEC=RATE*WELL(IWELLC,IW)
                 SRCSOL(JS,IS,KS)=SRCSOL(JS,IS,KS)+RATEC
               END IF
            END IF
         END IF
   10 CONTINUE
C
C  STOP IF WELL WITHIN TRANSPORT SUBGRID AND ICONLY=1
      IF(IWELSG.GT.0) THEN
         WRITE(IOUTS,*) ' ERROR,',IWELSG,' WELL NODES WITHIN',
     *      ' SUBGRID, BUT ICONLY=1, STOPPING'
         STOP
      END IF
C  STOP IF SOURCE WELL NODE WITHIN SUBGRID, BUT NO CONC DATA
      IF(IERSRC.GT.0) THEN
         WRITE(IOUTS,*) ' ERROR:',IERSRC,' SOURCE WELL NODES',
     *     ' WITHIN SUBGRID, BUT NO CONCENTRATION DATA, STOPPING'
         STOP
      END IF
C  WARN IF WELL NODE WITHIN SUBGRID, BUT NO FLOW ASSOC WITH IT
      IF(ITHKSG.GT.0) THEN
         WRITE(IOUTS,*) ' WARNING:',ITHKSG,' WELL NODES',
     *     ' SKIPPED WITHIN SUBGRID (IBOUND <= 0)'
      END IF
C
      RETURN
      END
