C
C     ELLDIS BUILD DISPERSION INTEGRAL 
C***********************************************************************
C
      SUBROUTINE ELLDIS(IBOUND,DISPCC,DISPCR,DISPCL,DISPRC,DISPRR,
     *               DISPRL,DISPLC,DISPLR,DISPLL,
     *      POR,THCK,RF,DIAGDS,TIMV,
     *      NCOL,NROW,NLAY,NSCOL,NSROW,NSLAY,NODESS,
     *      DELCOL,DELROW)
C
C***********************************************************************
C   ELLDIS IS CALLED AT THE FIRST TRANSPORT TIME STEP TO USE DISPERSION
C   COEFFICIENTS CALCULATED BY DSP6 TO BUILD THE LHS DISPERSION MATRIX,
C   DIAGDS.  DIAGDS HAS THE SAME 27 DIAGONAL FORM AS THE STORAGE MATRIX,
C   AND LIKE DIAGST IS STORED AS A 27 X NODESS ARRAY.
C   AT THE FIRST SOLVE (IMOV=1) DIAGST AND DIAGDS ARE SUMMED TO PRODUCE
C   THE SYSTEM MATRIX FOR SOLUTION, AND CONVERTED TO THE SLAP COLUMN
C   FORMAT USED BY THE SOLVER.  THE CONVERTED FORM OF DIAGDS+DIAGST IS
C   THEN STORED IN DIAGDS FOR USE IN FUTURE TRANSPORT SOLVES DURING 
C   DURING SINGLE FLOW TIME STEP.
C   
      DIMENSION  IBOUND(NCOL,NROW,NLAY),DISPCC(NSCOL,NSROW,NSLAY),
     *    DISPCR(NSCOL,NSROW,NSLAY),
     *    DISPCL(NSCOL,NSROW,NSLAY),DISPRC(NSCOL,NSROW,NSLAY),
     *    DISPRR(NSCOL,NSROW,NSLAY),DISPRL(NSCOL,NSROW,NSLAY),
     *    DISPLC(NSCOL,NSROW,NSLAY),DISPLR(NSCOL,NSROW,NSLAY),
     *    DISPLL(NSCOL,NSROW,NSLAY)
      DIMENSION POR(NODESS),THCK(NODESS),RF(NSCOL,NSROW,NSLAY),
     *    DIAGDS(27,NODESS),DELCOL(NCOL),DELROW(NROW)
      COMMON /SUBGRD/ ISCOL1,ISCOL2,ISROW1,ISROW2,ISLAY1,
     *  ISLAY2,ISUBGD
      COMMON /ELLAM/ CINV,RINV,BINV,HCINV,HRINV,HBINV,
     *               STINIT,ADINIT,STMASS,ADMASS,OLMASS,
     *               AZERO,
     *               NSC,NSR,NSL,NT,NCTF,NRTF,NLTF,
     *               NEIGHB(8,2),NSLOPE(3),
     *               IDTOP,IDMAX,NCOEF,NSCH,NSRH,NSLH
C
C   DISPCC CONTAINS POR*THCK*DCC/CDEL
C   DISPCR CONTAINS POR*THCK*DCR/(4*RDEL)
C   DISPCL CONTAINS POR*THCK*DCL/(4*B)
C   DISPRC CONTAINS POR*THCK*DRC/(4*CDEL)
C   DISPRR CONTAINS POR*THCK*DRR/RDEL
C   DISPRL CONTAINS POR*THCK*DRL/(4*B)
C   DISPLC CONTAINS POR*DLC/(4*CDEL)
C   DISPLR CONTAINS POR*DLR/(4*RDEL)
C   DISPLL CONTAINS POR*DLL/B
C
          NSRC=NSROW*NSCOL
        DO 131 KS=1,NSLAY
          K=ISLAY1+KS-1
        DO 131 IS=1,NSROW
          I=ISROW1+IS-1
        DO 131 JS=1,NSCOL
          J=ISCOL1+JS-1
          NODE=(KS-1)*NSRC+(IS-1)*NSCOL+JS
C
      IF (IBOUND(J,I,K).EQ.0) THEN
        DIAGDS(14,NODE)=0D0
        GOTO 131
      ENDIF
C
      RFPINV=1.D0/(RF(JS,IS,KS)*POR(NODE))
      TRFPR=TIMV*RFPINV
C
      JSP=JS+1
      JSM=JS-1
      ISP=IS+1
      ISM=IS-1
      KSP=KS+1
      KSM=KS-1
C
C  ADD DISPCX COEFFS TO LHS
C
      RTRFPR=DELROW(I)*TRFPR
C
C  FORWARD COEFFS
      IF (JS.NE.NSCOL) THEN
        IF (KS.NE.1) THEN
          DIAGDS(5,NODE)=DIAGDS(5,NODE)+RTRFPR*DISPCL(JS,IS,KS)
          DIAGDS(6,NODE)=DIAGDS(6,NODE)+RTRFPR*DISPCL(JS,IS,KS)
        ENDIF
        IF (IS.NE.1) THEN
          DIAGDS(11,NODE)=DIAGDS(11,NODE)+RTRFPR*DISPCR(JS,IS,KS)
          DIAGDS(12,NODE)=DIAGDS(12,NODE)+RTRFPR*DISPCR(JS,IS,KS)
        ENDIF
        DIAGDS(14,NODE)=DIAGDS(14,NODE)+RTRFPR*DISPCC(JS,IS,KS)
        DIAGDS(15,NODE)=DIAGDS(15,NODE)-RTRFPR*DISPCC(JS,IS,KS)
        IF (IS.NE.NSROW) THEN
          DIAGDS(17,NODE)=DIAGDS(17,NODE)-RTRFPR*DISPCR(JS,IS,KS)
          DIAGDS(18,NODE)=DIAGDS(18,NODE)-RTRFPR*DISPCR(JS,IS,KS)
        ENDIF
        IF (KS.NE.NSLAY) THEN
          DIAGDS(23,NODE)=DIAGDS(23,NODE)-RTRFPR*DISPCL(JS,IS,KS)
          DIAGDS(24,NODE)=DIAGDS(24,NODE)-RTRFPR*DISPCL(JS,IS,KS)
        ENDIF
      ENDIF
C  BACKWARD COEFFS
      IF (JS.NE.1) THEN
        IF (KS.NE.1) THEN
          DIAGDS(4,NODE)=DIAGDS(4,NODE)-RTRFPR*DISPCL(JSM,IS,KS)
          DIAGDS(5,NODE)=DIAGDS(5,NODE)-RTRFPR*DISPCL(JSM,IS,KS)
        ENDIF
        IF (IS.NE.1) THEN
          DIAGDS(10,NODE)=DIAGDS(10,NODE)-RTRFPR*DISPCR(JSM,IS,KS)
          DIAGDS(11,NODE)=DIAGDS(11,NODE)-RTRFPR*DISPCR(JSM,IS,KS)
        ENDIF
        DIAGDS(13,NODE)=DIAGDS(13,NODE)-RTRFPR*DISPCC(JSM,IS,KS)
        DIAGDS(14,NODE)=DIAGDS(14,NODE)+RTRFPR*DISPCC(JSM,IS,KS)
        IF (IS.NE.NSROW) THEN
          DIAGDS(16,NODE)=DIAGDS(16,NODE)+RTRFPR*DISPCR(JSM,IS,KS)
          DIAGDS(17,NODE)=DIAGDS(17,NODE)+RTRFPR*DISPCR(JSM,IS,KS)
        ENDIF
        IF (KS.NE.NSLAY) THEN
          DIAGDS(22,NODE)=DIAGDS(22,NODE)+RTRFPR*DISPCL(JSM,IS,KS)
          DIAGDS(23,NODE)=DIAGDS(23,NODE)+RTRFPR*DISPCL(JSM,IS,KS)
        ENDIF
      ENDIF
C
C  ADD DISPRX COEFFS TO LHS
C
      CTRFPR=DELCOL(J)*TRFPR
C
C  FORWARD COEFFS
      IF (IS.NE.NSROW) THEN
        IF (KS.NE.1) THEN
          DIAGDS(5,NODE)=DIAGDS(5,NODE)+CTRFPR*DISPRL(JS,IS,KS)
          DIAGDS(8,NODE)=DIAGDS(8,NODE)+CTRFPR*DISPRL(JS,IS,KS)
        ENDIF
        IF (JS.NE.1) THEN
          DIAGDS(13,NODE)=DIAGDS(13,NODE)+CTRFPR*DISPRC(JS,IS,KS)
          DIAGDS(16,NODE)=DIAGDS(16,NODE)+CTRFPR*DISPRC(JS,IS,KS)
        ENDIF
        DIAGDS(14,NODE)=DIAGDS(14,NODE)+CTRFPR*DISPRR(JS,IS,KS)
        DIAGDS(17,NODE)=DIAGDS(17,NODE)-CTRFPR*DISPRR(JS,IS,KS)
        IF (JS.NE.NSCOL) THEN
          DIAGDS(15,NODE)=DIAGDS(15,NODE)-CTRFPR*DISPRC(JS,IS,KS)
          DIAGDS(18,NODE)=DIAGDS(18,NODE)-CTRFPR*DISPRC(JS,IS,KS)
        ENDIF
        IF (KS.NE.NSLAY) THEN
          DIAGDS(23,NODE)=DIAGDS(23,NODE)-CTRFPR*DISPRL(JS,IS,KS)
          DIAGDS(26,NODE)=DIAGDS(26,NODE)-CTRFPR*DISPRL(JS,IS,KS)
        ENDIF
      ENDIF
C  BACKWARD COEFFS
      IF (IS.NE.1) THEN
        IF (KS.NE.1) THEN
          DIAGDS(2,NODE)=DIAGDS(2,NODE)-CTRFPR*DISPRL(JS,ISM,KS)
          DIAGDS(5,NODE)=DIAGDS(5,NODE)-CTRFPR*DISPRL(JS,ISM,KS)
        ENDIF
        IF (JS.NE.1) THEN
          DIAGDS(10,NODE)=DIAGDS(10,NODE)-CTRFPR*DISPRC(JS,ISM,KS)
          DIAGDS(13,NODE)=DIAGDS(13,NODE)-CTRFPR*DISPRC(JS,ISM,KS)
        ENDIF
        DIAGDS(11,NODE)=DIAGDS(11,NODE)-CTRFPR*DISPRR(JS,ISM,KS)
        DIAGDS(14,NODE)=DIAGDS(14,NODE)+CTRFPR*DISPRR(JS,ISM,KS)
        IF (JS.NE.NSCOL) THEN
          DIAGDS(12,NODE)=DIAGDS(12,NODE)+CTRFPR*DISPRC(JS,ISM,KS)
          DIAGDS(15,NODE)=DIAGDS(15,NODE)+CTRFPR*DISPRC(JS,ISM,KS)
        ENDIF
        IF (KS.NE.NSLAY) THEN
          DIAGDS(20,NODE)=DIAGDS(20,NODE)+CTRFPR*DISPRL(JS,ISM,KS)
          DIAGDS(23,NODE)=DIAGDS(23,NODE)+CTRFPR*DISPRL(JS,ISM,KS)
        ENDIF
      ENDIF
C
C  ADD DISPLX COEFFS TO LHS
C
      CRTRFPR=DELCOL(J)*DELROW(I)*TRFPR
C
C  FORWARD COEFFS
      IF (KS.NE.NSLAY) THEN
        IF (JS.NE.1) THEN
          DIAGDS(13,NODE)=DIAGDS(13,NODE)+CRTRFPR*DISPLC(JS,IS,KS)
          DIAGDS(22,NODE)=DIAGDS(22,NODE)+CRTRFPR*DISPLC(JS,IS,KS)
        ENDIF
        IF (IS.NE.1) THEN
          DIAGDS(11,NODE)=DIAGDS(11,NODE)+CRTRFPR*DISPLR(JS,IS,KS)
          DIAGDS(20,NODE)=DIAGDS(20,NODE)+CRTRFPR*DISPLR(JS,IS,KS)
        ENDIF
        DIAGDS(14,NODE)=DIAGDS(14,NODE)+CRTRFPR*DISPLL(JS,IS,KS)
        DIAGDS(23,NODE)=DIAGDS(23,NODE)-CRTRFPR*DISPLL(JS,IS,KS)
        IF (JS.NE.NSCOL) THEN
          DIAGDS(15,NODE)=DIAGDS(15,NODE)-CRTRFPR*DISPLC(JS,IS,KS)
          DIAGDS(24,NODE)=DIAGDS(24,NODE)-CRTRFPR*DISPLC(JS,IS,KS)
        ENDIF
        IF (IS.NE.NSROW) THEN
          DIAGDS(17,NODE)=DIAGDS(17,NODE)-CRTRFPR*DISPLR(JS,IS,KS)
          DIAGDS(26,NODE)=DIAGDS(26,NODE)-CRTRFPR*DISPLR(JS,IS,KS)
        ENDIF
      ENDIF
C  BACKWARD COEFFS
      IF (KS.NE.1) THEN
        IF (JS.NE.1) THEN
          DIAGDS(4,NODE)=DIAGDS(4,NODE)-CRTRFPR*DISPLC(JS,IS,KSM)
          DIAGDS(13,NODE)=DIAGDS(13,NODE)-CRTRFPR*DISPLC(JS,IS,KSM)
        ENDIF
        IF (IS.NE.1) THEN
          DIAGDS(2,NODE)=DIAGDS(2,NODE)-CRTRFPR*DISPLR(JS,IS,KSM)
          DIAGDS(11,NODE)=DIAGDS(11,NODE)-CRTRFPR*DISPLR(JS,IS,KSM)
        ENDIF
        DIAGDS(5,NODE)=DIAGDS(5,NODE)-CRTRFPR*DISPLL(JS,IS,KSM)
        DIAGDS(14,NODE)=DIAGDS(14,NODE)+CRTRFPR*DISPLL(JS,IS,KSM)
        IF (JS.NE.NSCOL) THEN
          DIAGDS(6,NODE)=DIAGDS(6,NODE)+CRTRFPR*DISPLC(JS,IS,KSM)
          DIAGDS(15,NODE)=DIAGDS(15,NODE)+CRTRFPR*DISPLC(JS,IS,KSM)
        ENDIF
        IF (IS.NE.NSROW) THEN
          DIAGDS(8,NODE)=DIAGDS(8,NODE)+CRTRFPR*DISPLR(JS,IS,KSM)
          DIAGDS(17,NODE)=DIAGDS(17,NODE)+CRTRFPR*DISPLR(JS,IS,KSM)
        ENDIF
      ENDIF
C
131   CONTINUE
C
      RETURN
      END
C
